# -*- coding: utf-8 -*-
"""
  Copyright 2015 Grégory Soutadé

  This file is part of Dénote.

  Dénote is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dénote is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dénote.  If not, see <http://www.gnu.org/licenses/>.
"""

from django.conf.urls import patterns, include, url

urlpatterns = patterns('',
    url(r'^index[/]?$',   'denote.views.index',   name='index'),
    url(r'^[/]?$',        'denote.views.index',   name='index'),
    url(r'^disconnect?$', 'denote.views.disconnect',   name='disconnect'),
    url(r'^user/add$','denote.views.new_user',   name='new_user'),
    url(r'^user/edit$','denote.views.edit_user',   name='edit_user'),
    url(r'^note/add$', 'denote.views.add_note', name='add_note'),
    url(r'^note/(\d+)$', 'denote.views.note', name='note'),
    url(r'^note/(\d+)/(\d+)$', 'denote.views.public_note', name='public_note'),
    url(r'^public_notes$', 'denote.views.public_notes', name='public_notes'),
    url(r'^category/edit/(\d)$','denote.views.edit_category',   name='edit_category'),
    url(r'^preferences$', 'denote.views.preferences', name='preferences'),
    url(r'^search$', 'denote.views.search', name='search'),
    url(r'^generate_search_index$', 'denote.views.generate_search_index', name='generate_search_index'),
                       
    url(r'^template/add$','denote.views.add_template',   name='add_template'),
    url(r'^template/(\d+)$','denote.views.template',   name='template'),
    url(r'^templates$','denote.views.templates',   name='templates'),
)
